﻿using Harmony;
using System.Reflection;
using UnityEngine;

public class NoItemDurability : Mod
{
    HarmonyInstance instance;
    public void Start()
    {
        instance = HarmonyInstance.Create("fr.tekgamer.noitemdurability");
        instance.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("Mod NoItemDurability has been loaded!");
    }

    public void OnModUnload()
    {
        instance.UnpatchAll();
        Debug.Log("Mod NoItemDurability has been unloaded!");
    }
}

[HarmonyPatch(typeof(Item))]
[HarmonyPatch("Update")]
internal class Patch_ItemUpdate
{
    public static void Prefix(Item __instance)
    {
        if (__instance.m_Info.IsFood())
        {
            __instance.m_Info.m_CreationTime = MainLevel.Instance.m_TODSky.Cycle.GameTime;
        }
        if (__instance.m_Info.IsAxe() || __instance.m_Info.IsBow() || __instance.m_Info.IsFishingRod() || __instance.m_Info.IsArrow() || __instance.m_Info.IsArmor() || __instance.m_Info.IsBowl() || __instance.m_Info.IsKnife() || __instance.m_Info.IsMachete() || __instance.m_Info.IsLiquidContainer() || __instance.m_Info.IsTool() || __instance.m_Info.IsWeapon())
        {
            __instance.m_Info.m_Health = __instance.m_Info.m_MaxHealth;
        }
    }
}